#include <GL/glut.h>
#include <stdio.h>
#include <vector>
#include <list>
#include "GameObj.h"
#include "Ast.h"
#include "AstFract.h"

#ifdef _WIN32
#define drand48() (((float) rand())/((float) RAND_MAX))
#define srand48(x) (srand((x)))
#endif

void AstFract::Build(int SplitNum)
{
 list<Point3f> pp;
 pp.push_back(Point3f( 0, .7, 0));
 pp.push_back(Point3f(-1,-1, 0));
 pp.push_back(Point3f( 1,-1, 0));

 for(int i=0; i<SplitNum; ++i)
		Split(pp); 

 P.resize(pp.size());
 copy(pp.begin(),pp.end(),P.begin());
}

void AstFract::Draw()
{
	glPushMatrix();
	glDisable(GL_LIGHTING);
	glTranslate(p);
	glRotatef(angle,0,0,1);
	glScalef(size,size,size);
	vector<Point3f>::iterator i;
	glBegin(GL_LINE_LOOP);
	glColor3f(.7,.6,.6);
  for(i=P.begin();i!=P.end();++i)
		glVertex(*i);
	glEnd();
	glEnable(GL_LIGHTING);
	glPopMatrix();
}

void AstFract::Split( list<Point3f> &l)
{
	list<Point3f>::iterator li,lib;

	Point3f cm(0,0,0); //center of mass
	float r;   // Asteroid radius
	float el;  // Current Edge Lenght

	Point3f cmv; // center of mass vector
	
	for(li=l.begin();li!=l.end();++li)
		cm+=*li;
	cm/=l.size();
	
	Point3f mp; // mid point
  Point3f np; // the new point
  li=l.begin();  // the first element
  lib=--l.end(); // the last element
  for(li=l.begin();li!=l.end();++li){
		mp=((*li)+(*lib))/2.0;
		el=Distance(*li,*lib);
		r=(Distance(*li,cm)+Distance(*lib,cm))/2.0;
		cmv=Normalize(mp-cm);
		np=cm+cmv*r+cmv*(drand48()-.5)*el/2.0;
		l.insert(li,np);
		lib=li;
	}
}